<template>
  <g>
    <text
      ref="text"
      :transform="`scale(${1 / zoom}, 1)`"
      class="canvas-timeline-text"
      :x="computedPosition * zoom"
      :y="y"
    >
      {{ label }}
    </text>
  </g>
</template>

<script lang="ts">
import type { Pixel } from '@/data';
import {
  Component, Prop, Ref, Vue, Watch,
} from 'vue-property-decorator';

@Component
export default class TimelineMarker extends Vue {
  @Prop({ default: 0 })
  y!: number;

  @Prop({ required: true })
  label!: string;

  @Prop({ required: true })
  position!: Pixel;

  @Prop({ default: 1 })
  zoom!: number;

  @Ref('text')
  readonly text!: SVGTextContentElement;

  computedPosition: Pixel = 0 as Pixel;

  @Watch('label')
  @Watch('position')
  @Watch('zoom')
  updateText() {
    this.$nextTick(() => {
      this.computedPosition = (
        this.position - (this.text.getComputedTextLength() * (1 / this.zoom)) / 2
      ) as Pixel;
    });
  }

  mounted() {
    this.updateText();
  }
}
</script>

<style lang="scss" scoped>
.canvas-timeline-text {
  color: black;
  opacity: 0.3;
  font-family: "Roboto", "Noto", sans-serif;
  font-size: 80%;
  font-weight: bold;
  pointer-events: none;
}
</style>
